.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDE    \masm32\include\shell32.inc
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\shell32.lib

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD

.CONST

WM_SHELLNOTIFY EQU WM_USER + 5
IDI_TRAY       EQU    0
IDM_RESTORE    EQU 1000
IDM_EXIT       EQU 1010

.DATA

ClassName     DB "TrayIconWinClass", 0
AppName       DB "Ikona Zasobnika Systemowego", 0
RestoreString DB "&Przywr", 0
ExitString    DB "&Zakocz program", 0

.DATA?

hInstance  DD ?
note       NOTIFYICONDATA <>
hPopupMenu DD ?

.CODE

start:
    INVOKE GetModuleHandle,  NULL
    mov    hInstance, eax
    INVOKE WinMain,  hInstance, NULL, NULL,  SW_SHOWDEFAULT
    INVOKE ExitProcess, eax

WinMain PROC hInst:     HINSTANCE,\
             hPrevInst: HINSTANCE,\
             CmdLine:   LPSTR,\
             CmdShow:   DWORD

LOCAL wc:   WNDCLASSEX
LOCAL msg:  MSG
LOCAL hwnd: HWND

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style,  CS_HREDRAW OR CS_VREDRAW OR CS_DBLCLKS
    mov    wc.lpfnWndProc,  OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, NULL
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_APPWORKSPACE
    mov    wc.lpszMenuName, NULL
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx,  ADDR wc
    INVOKE CreateWindowEx, WS_EX_CLIENTEDGE,\
                           ADDR ClassName, ADDR AppName,\
                           WS_OVERLAPPED + WS_CAPTION + \
                           WS_SYSMENU + WS_MINIMIZEBOX + \
                           WS_MAXIMIZEBOX + WS_VISIBLE,\
                           CW_USEDEFAULT, CW_USEDEFAULT, 350, 200,\
                           NULL, NULL, hInst, NULL
    mov   hwnd, eax

    .WHILE TRUE
        INVOKE GetMessage,  ADDR msg, NULL, 0, 0
        .BREAK .IF (!eax)
        INVOKE TranslateMessage,  ADDR msg
        INVOKE DispatchMessage,  ADDR msg
    .ENDW

    mov eax, msg.wParam
    ret

WinMain ENDP

WndProc PROC hWnd:HWND,  uMsg:UINT,  wParam:WPARAM,  lParam:LPARAM

LOCAL pt:   POINT
LOCAL rect: RECT

    .IF uMsg==WM_CREATE
        INVOKE CreatePopupMenu
        mov    hPopupMenu, eax
        INVOKE AppendMenu, hPopupMenu, MF_STRING, IDM_RESTORE,\
                           ADDR RestoreString
        INVOKE AppendMenu, hPopupMenu, MF_STRING, IDM_EXIT,\
                           ADDR ExitString
    .ELSEIF uMsg==WM_DESTROY
        INVOKE DestroyMenu, hPopupMenu
        INVOKE PostQuitMessage, NULL
    .ELSEIF uMsg==WM_SIZE
        .IF wParam==SIZE_MINIMIZED
            mov    note.cbSize, SIZEOF NOTIFYICONDATA
            push   hWnd
            pop    note.hwnd
            mov    note.uID, IDI_TRAY
            mov    note.uFlags, NIF_ICON+NIF_MESSAGE+NIF_TIP
            mov    note.uCallbackMessage, WM_SHELLNOTIFY
            INVOKE LoadIcon, NULL, IDI_WINLOGO
            mov    note.hIcon, eax
            INVOKE lstrcpy, ADDR note.szTip, ADDR AppName
            INVOKE ShowWindow, hWnd, SW_HIDE
            INVOKE Shell_NotifyIcon, NIM_ADD, ADDR note
        .ENDIF
    .ELSEIF uMsg==WM_COMMAND
        .IF lParam==0
            INVOKE Shell_NotifyIcon, NIM_DELETE, ADDR note
            mov    eax, wParam
            .IF ax==IDM_RESTORE
                INVOKE ShowWindow, hWnd, SW_RESTORE
            .ELSE
                INVOKE DestroyWindow, hWnd
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_SHELLNOTIFY
        .IF wParam==IDI_TRAY
            .IF lParam==WM_RBUTTONDOWN
                INVOKE GetCursorPos, ADDR pt
                INVOKE SetForegroundWindow, hWnd
                INVOKE TrackPopupMenu, hPopupMenu,\
                                       TPM_RIGHTALIGN OR TPM_RIGHTBUTTON,\
                                       pt.x, pt.y, NULL, hWnd, NULL
                INVOKE PostMessage, hWnd, WM_NULL, 0, 0
            .ELSEIF lParam==WM_LBUTTONDBLCLK
                INVOKE SetForegroundWindow, hWnd
                INVOKE SendMessage, hWnd, WM_COMMAND, IDM_RESTORE, 0
            .ENDIF
        .ENDIF
    .ELSE
        INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam		
        ret
    .ENDIF

    xor eax, eax
    ret

WndProc ENDP

END start
